/*********************************************************************
* ADC-TWI-Slave (TWI via USI)
*
* Uwe Berger; 2012
*
**********************************************************************/

#include <avr/io.h>
#include <avr/interrupt.h>

#include "USI_TWI_Slave.h"

// TWI-Slave-Adresse
#define TWI_SLAVE_ADDR	0x12				

   
//*********************************************************************
//*********************************************************************
int main(void)
{
	uint8_t adc_adr;
	int adc_val;
  
	// TWI initialisieren und Slave-Adresse setzen
	USI_TWI_Slave_Initialise( TWI_SLAVE_ADDR );
	
	DIDR0 |= (1<<ADC3D) | (1<<ADC2D);
	
	sei();
	

	for(;;)	{

		//*** TWI-Verarbeitung
		if(USI_TWI_Data_In_Receive_Buffer()) {
			// ein Byte vom Master empfangen 
			adc_adr = USI_TWI_Receive_Byte();

			ADMUX = 0;
			switch (adc_adr) {
				case 0: {
					ADMUX |= (1<<MUX1);
					break;
				}
				case 1: {
					ADMUX |= (1<<MUX1) | (1<<MUX0);
					break;
				}
			}
			ADCSRA = (1<<ADEN) | (1<<ADPS0);
			// Dummy-Messung
			ADCSRA |= (1<<ADSC);              
			while (ADCSRA & (1<<ADSC));
			adc_val = ADCW;
			// eigentliche Messung
			ADCSRA |= (1<<ADSC);  
			while (ADCSRA & (1<<ADSC));
			adc_val = ADCW;
			// ADC wieder ausschalten
			ADCSRA=0;

			USI_TWI_Transmit_Byte(adc_val%256);
			USI_TWI_Transmit_Byte(adc_val/256);	

		}
	}
}

